/* BEGIN NOTICE

This software was written by Peter DiFalco and John Sarraille.  The
algorithm employed was inspired by the paper entitled "A Fast
Algorithm To Determine Fractal Dimensions By Box Counting", which was
written by Liebovitch and Toth, and which appeared in the journal
"Physics Letters A", volume 141, pp 386-390, (1989).

This software is not warranteed: use at your own risk.  Unlimited
permission to distribute this software is granted, so long as this
notice is included in all copies made.

August 19, 1991

END NOTICE */

/*
fd.h
  Header file for Fractal Dimension Programs
*/

#define MASK(n)		(((unsigned long int) 1)<<(n))
#define IS_A_ONE(x,n)	((x) & MASK(n))
#define false		(0)
#define true		(1)
#define sizul		sizeof(unsigned long int)
#define numbits		(8*sizul)
#define outputfile	(false)
#define give_counts	(true)
#define del_norm_file	(true)

typedef unsigned long int	ulong;

typedef struct X_Y_marker
{
	ulong xcoord,		/* x-coordinate */
	      ycoord;		/* y-coordinate */
	int   marker;		/* flag for end of queue */
} X_Y_marker;

typedef struct QNode
{
	X_Y_marker elt;		/* element of the queue node */
	struct QNode *next;	/* pointer to next QNode */
} QNode;

typedef struct QHeader
{
	struct QNode *Qfront,	/* pointers to the front */
		     *Qrear;	/* and rear of the queue */
} QHeader;

typedef QHeader *Queue;		/* A queue */
